/*
 *  TU Eindhoven
 *  Eindhoven, The Netherlands
 *
 *  Name            :   statespace.h
 *
 *  Author          :   Sander Stuijk (sander@ics.ele.tue.nl)
 *
 *  Date            :   April 5, 2006
 *
 *  Function        :   State-space
 *
 *  History         :
 *      05-04-06    :   Initial version.
 *
 * $Id: statespace.h,v 1.1.1.1 2007/10/02 10:59:46 sander Exp $
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * In other words, you are welcome to use, share and improve this program.
 * You are forbidden to forbid anyone else to use, share and improve
 * what you give them.   Happy coding!
 */

#ifndef SDF_OUTPUT_STATESPACE_STATESPACE_H_INCLUDED
#define SDF_OUTPUT_STATESPACE_STATESPACE_H_INCLUDED

#include "../../base/timed/graph.h"
#include "../../resource_allocation/mpsoc_arch/graph.h"

/**
 * outputSelfTimedStateSpace ()
 * Output all states visited during the self-timed execution of the graph gr.
 */
extern
void outputSelfTimedStateSpace(TimedSDFgraph *gr, ostream &out,
        unsigned long long stackSz = 1000, unsigned long long hashSz = 10000);

/**
 * outputConstrainedSelfTimedStateSpace ()
 * Output all states visited during the constrained self-timed execution of the
 * graph gr.
 */
extern
void outputConstrainedSelfTimedStateSpace(TimedSDFgraph *gr,  PlatformGraph *ap,
        ostream &out, unsigned long long stackSz = 1000, 
        unsigned long long hashSz = 10000);

#endif
