/*
 *  TU Eindhoven
 *  Eindhoven, The Netherlands
 *
 *  Name            :   mp_earliestdeadline.h
 *
 *  Author          :   Sander Stuijk (sander@ics.ele.tue.nl)
 *
 *  Date            :   September 14, 2005
 *
 *  Function        :   Earliest Deadline First scheduler for multi-processor
 *
 *  History         :
 *      14-09-05    :   Initial version.
 *
 * $Id: mp_earliestdeadline.h,v 1.1.1.1 2007/10/02 10:59:47 sander Exp $
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * In other words, you are welcome to use, share and improve this program.
 * You are forbidden to forbid anyone else to use, share and improve
 * what you give them.   Happy coding!
 */

#ifndef SDF_RESOURCE_ALLOCATION_SCHEDULING_MP_EARLIESTDEADLINE_H_INCLUDED
#define SDF_RESOURCE_ALLOCATION_SCHEDULING_MP_EARLIESTDEADLINE_H_INCLUDED

#include "sp_earliestdeadline.h"

class MPearliestDeadlineScheduler : public scheduler
{
public:
    // Constructor
    MPearliestDeadlineScheduler();
    
    // Destructor
    ~MPearliestDeadlineScheduler();
    
    // Run the scheduler on the graph g
    int run(TimedSDFgraph *g);
    
    // Check whether all preconditions are satisfied
    int check(TimedSDFgraph *g);
    
    // Reset the scheduler
    void reset();

    // Schedule
    MPschedule *getSchedule() { return schedule; };

private:
    // Schedule
    TimedSDFgraph *createClusterGraph(TimedSDFgraph *g, SDFactorCluster *c);
    bool isActorInCluster(SDFactor *a, SDFactorCluster *c);
    bool isActorConnectedToCluster(SDFactor *a, SDFactorCluster *c);

private:
    // Schedule
    MPschedule *schedule;
};

#endif
